package org.dasein.cloud.jclouds.terremark;

import static com.google.common.util.concurrent.MoreExecutors.sameThreadExecutor;

import org.dasein.cloud.AbstractCloud;
import org.dasein.cloud.ProviderContext;
import org.dasein.cloud.services.access.AccessServices;
import org.dasein.cloud.services.accounting.AccountingServices;
import org.dasein.cloud.services.address.AddressServices;
import org.dasein.cloud.services.cdn.ContentDistributionServices;
import org.dasein.cloud.services.dc.DataCenterServices;
import org.dasein.cloud.services.disk.SnapshotServices;
import org.dasein.cloud.services.disk.VolumeServices;
import org.dasein.cloud.services.firewall.FirewallServices;
import org.dasein.cloud.services.image.ImageServices;
import org.dasein.cloud.services.lb.LoadBalancerServices;
import org.dasein.cloud.services.scaling.ScalingServices;
import org.dasein.cloud.services.server.ServerServices;
import org.dasein.cloud.services.storage.StorageServices;
import org.jclouds.compute.ComputeServiceContextFactory;
import org.jclouds.concurrent.config.ExecutorServiceModule;
import org.jclouds.logging.log4j.config.Log4JLoggingModule;
import org.jclouds.rest.RestContext;
import org.jclouds.vcloud.terremark.TerremarkVCloudExpressAsyncClient;
import org.jclouds.vcloud.terremark.TerremarkVCloudExpressClient;

import com.google.common.collect.ImmutableSet;

public class Terremark extends AbstractCloud {
    public Terremark() { }

    @Override    
    public AccessServices getAccessServices() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public AccountingServices getAccountingServices() {
        // TODO Auto-generated method stub
        return null;
    }

    private transient PublicIp addressServices = null;
    
    @Override
    public AddressServices getAddressServices() {
        if( addressServices == null ) {
            addressServices = new PublicIp(this);
        }
        return addressServices;
    }

    @Override
    public ContentDistributionServices getCdnServices() {
        // TODO Auto-generated method stub
        return null;
    }

    RestContext<TerremarkVCloudExpressClient,TerremarkVCloudExpressAsyncClient> getCloudClient() {
        ProviderContext ctx = getContext();
        String user = new String(ctx.getAccessPublic());
        String key = new String(ctx.getAccessPrivate());
        return new ComputeServiceContextFactory().createContext("trmk-vcloudexpress", user, key, ImmutableSet.of(new Log4JLoggingModule(), new ExecutorServiceModule(sameThreadExecutor(), sameThreadExecutor()))).getProviderSpecificContext();

    }
    
    @Override
    public String getCloudName() {
        return "Terremark";
    }

    private transient Vdc dataCenterServices = null;
    
    @Override
    public DataCenterServices getDataCenterServices() {
        if( dataCenterServices == null ) {
            dataCenterServices = new Vdc(this);
        }
        return dataCenterServices;
    }

    @Override
    public FirewallServices getFirewallServices() {
        // TODO Auto-generated method stub
        return null;
    }

    private transient Template imageServices = null;
    
    @Override
    public ImageServices getImageServices() {
        if( imageServices == null ) {
            imageServices = new Template(this);
        }
        return imageServices;
    }

    @Override
    public LoadBalancerServices getLoadBalancerServices() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public String getProviderName() {
        return "Terremark";
    }

    @Override
    public ScalingServices getScalingServices() {
        // TODO Auto-generated method stub
        return null;
    }

    private transient VApp serverServices = null;
    
    @Override
    public ServerServices getServerServices() {
        if( serverServices == null ) {
            serverServices = new VApp(this);
        }
        return serverServices;
    }

    @Override
    public SnapshotServices getSnapshotServices() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public StorageServices getStorageServices() {
        // TODO Auto-generated method stub
        return null;
    }
    @Override
    public VolumeServices getVolumeServices() {
        // TODO Auto-generated method stub
        return null;
    }

}
